Index: Singular/LIB/monomial.lib
===================================================================
--- Singular/LIB/monomial.lib	(revision 7f8587b3752e6d6a92df017bafdfb3d03198e66b)
+++ Singular/LIB/monomial.lib	(revision abbd22e3508e31d6abd926f194f4cb62f9365784)
@@ -1285,21 +1241,21 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos el sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Generadores monomiales, hallamos el sistema minimal
+    I = minbase(I);
+  }
   // Ya tenemos el ideal generado por la BASE MINIMAL
   // Usamos la funcion "soporte" que hemos creado, para saber que
@@ -1307,6 +1263,6 @@
   // mismas y tambien cuales son los generadores del ideal donde
   // tenemos que comprobar si aparecen tales variables.
-  nvar = nvars(R);
-  m = size(I);
+  nvar = nvars(basering);
+  m = ncols(I);
   // Inicializo la ultima componente del vector para que contenga a
   // todas las variables (el subindice de la variable es el lugar
@@ -1317,18 +1273,18 @@
   // w = lugar de los generadores de I que son producto de mas de una variable.
   for (i = 1 ; i <= m ; i++)
-    {
-      sub_in = soporte(I[i]);
-      // Si soporte <> 0 la variable aparece sola, en caso contrario
-      // el generador es producto de mas de una variable
-      if (sub_in <> 0)
-        {
-          v[sub_in] = 1;
-        }
-      else
-        {
-          w[k] = i;
-          k++;
-        }
-    }
+  {
+    sub_in = soporte(I[i]);
+    // Si soporte <> 0 la variable aparece sola, en caso contrario
+    // el generador es producto de mas de una variable
+    if (sub_in <> 0)
+    {
+      v[sub_in] = 1;
+    }
+    else
+    {
+      w[k] = i;
+      k++;
+    }
+  }
   // Ahora solo hay que ver que no aparecen variables distintas de
   // las que tenemos marcadas con 1 en v.
@@ -1337,23 +1293,23 @@
   // son producto de una sola variable, luego es primario.
   if (l == 1 && w[1] == 0)
-    {
-      return(1);
-    }
+  {
+    return(1);
+  }
   // Estudiamos el exponente de los generadores de I oportunos (los
   // que nos indica w).
   for (i = 1 ; i <= l ; i++)
-    {
-      exp_gen = leadexp(I[w[i]]);
-      for (j = 1 ; j <= nvar ; j++)
-        {
-          if (v[j] == 0)
-            {
-              if (exp_gen[j] <> 0)
-                {
-                  return (0);
-                }
-            }
-        }
-    }
+  {
+    exp_gen = leadexp(I[w[i]]);
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (v[j] == 0)
+      {
+        if (exp_gen[j] <> 0)
+        {
+          return (0);
+        }
+      }
+    }
+  }
   // Si hemos recorrido todo el ideal sin que salte el "for"
   // quiere decir que no se ha contradicho la caracterizacion,
@@ -1386,33 +1342,33 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Generadores monomiales, hallamos sistema minimal
+    I = minbase(I);
+  }
   // Ya tenemos el ideal generado por la BASE MINIMAL
-  n = size(I);
+  n = ncols(I);
   // La funcion soporte devuelve 0 si el monomio es producto de mas
   // de una variable. Chequeamos generador a generador si el ideal
   // esta generado por potencias de variables.
   for (i = 1 ; i <= n ; i ++)
-    {
-      if (soporte(I[i]) == 0)
-        {
-          return(0);
-        }
-    }
+  {
+    if (soporte(I[i]) == 0)
+    {
+      return(0);
+    }
+  }
   return (1);
 }
@@ -1435,6 +1391,5 @@
 "
 {
-  def R = basering;
-  int  nvar  = nvars(R);
+  int  nvar  = nvars(basering);
   // Declaracion de variables
   int i,j,k,cont,sizI;
@@ -1445,23 +1400,23 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Generadores monomiales, hallamos sistema minimal
+    I = minbase(I);
+  }
   // Ya tenemos el ideal generado por la BASE MINIMAL
-  sizI = size(I);
+  sizI = ncols(I);
   // Comprobamos que entre los generadores minimales aparece una
   // potencia de cada. Cuando encontramos un generador que es potencia
@@ -1469,18 +1424,18 @@
   cont = 0;
   for (i = 1 ; i <= sizI ; i++)
-    {
-      if (soporte(I[i]) <> 0)
-        {
-          cont ++;
-          // Solo volvemos a evaluar en caso de que hayamos aumentado
-          if (cont == nvar)
-            {
-              // Ya hemos encontrado que todas las variables aparrecen en
-              // el sistema minimal como potencia pura. No queremos seguir
-              // buscando
-              return (1);
-            }
-        }
-    }
+  {
+    if (soporte(I[i]) <> 0)
+    {
+      cont ++;
+      // Solo volvemos a evaluar en caso de que hayamos aumentado
+      if (cont == nvar)
+      {
+        // Ya hemos encontrado que todas las variables aparrecen en
+        // el sistema minimal como potencia pura. No queremos seguir
+        // buscando
+        return (1);
+      }
+    }
+  }
   // Si ha salido, es que faltan variables
   return(0);
@@ -1504,6 +1459,5 @@
 "
 {
-  def R = basering;
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   // Declaracion de variables
   int sizI,i,j,k;
@@ -1514,46 +1468,46 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos sistema minimal
-      I = minbase(I);
-    }
+  {
+    // Generadores monomiales, hallamos sistema minimal
+    I = minbase(I);
+  }
   // Ya tenemos el ideal generado por la BASE MINIMAL
-  sizI = size(I);
+  sizI = ncols(I);
   // Creamos una lista que tenga los exponentes de todos los
   // generadores.
   for (i = 1 ; i <= sizI ; i++)
-    {
-      exp[i] = leadexp(I[i]);
-    }
+  {
+    exp[i] = leadexp(I[i]);
+  }
   // Ahora hay que ver si alguno se repite, y si uno de ellos
   // lo hace, ya no es gen?rico.
   for (i = 1 ; i <= nvar ; i++)
-    {
-      for (j = 1 ; j <= sizI-1 ; j++)
-        {
-          for (k = j+1 ; k <= sizI ; k++)
-            {
-              // Notar que no se pueden repetir si la variable realmente
-              // aparece en el generador, es decir, exponente >1.
-              if (exp[j][i] == exp[k][i] & exp[j][i] <> 0)
-                {
-                  return (0);
-                }
-            }
-        }
-    }
+  {
+    for (j = 1 ; j <= sizI-1 ; j++)
+    {
+      for (k = j+1 ; k <= sizI ; k++)
+      {
+        // Notar que no se pueden repetir si la variable realmente
+        // aparece en el generador, es decir, exponente >1.
+        if (exp[j][i] == exp[k][i] & exp[j][i] <> 0)
+        {
+          return (0);
+        }
+      }
+    }
+  }
   return (1);
 }
@@ -1577,91 +1531,91 @@
 "
 {
-  def R = basering;
-  int nvar = nvars(R);
+ // El ideal trivial no es monomial.
+  if ( size(I) == 0 )
+  {
+    ERROR("the ideal is zero, hence not monomial.");
+  }
   // VARIABLES
   int control,sizSum,sumandos,i,j,k,cont;
-  intvec index,indexAux,vaux,w;
-  list sum, sumAux;
-  // La base del ideal tiene que ser la monomial
- // El ideal trivial no es monomial.
-  if ( size(I) == 0 )
-    {
-      ERROR("the ideal is zero, hence not monomial.");
-    }
  // COMPROBACIONES
   control = checkIdeal(I);
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          // Sabemos que I ya viene dado por el sistema minimal de
-          // generadores, aunque aqui no sea necesario.
-          I = isMon[2];
-        }
-    }
-  // Si el ideal es artiniano, es 0-dimensional
-  if (isartinianMon(I) == 1)
-    {
-      return (0);
-    }
-  int sizI = size(I);
-  // v(i) = vector con sizI entradas y donde cada entrada "j" se corresponde
-  //        con el exponente del generador "i" en la variable "j"
-  for (i = 1 ; i <= nvar ; i++)
-    {
-      intvec v(i);
-      for (j = 1 ; j <= sizI ;j++ )
-        {
-          v(i)[j] = leadexp(I[j])[i];
-        }
-    }
-  // Vamos a guardar en el vector "index" la ultima variable que se ha
-  // sumado y en cada "sum(i)" el vector suma que se corresponde con la
-  // entrada "i" del vector index.
-  // Inicializo los valores de index y de cada sum
-  w[sizI] = 0;
-  sum[1] = w;
-  index[1] = 0;
-  sizSum = 1;
-  while ( 1 )
-    {
-      cont = 1;
-      sumandos ++;
-      for (i = 1 ; i <= sizSum ; i ++)
-        {
-          for (j = index[i] + 1 ; j <= nvar ; j ++)
-            {
-              w = sum[i];
-              vaux = w + v(j);
-              // Comprobamos
-              for (k = 1 ; k <= sizI ; k ++)
-                {
-                  if (vaux[k] == 0)
-                    {
-                      break;
-                    }
-                }
-              if (k == sizI +1)
-                {
-                  return (nvar - sumandos);
-                }
-              if (j <> nvar)
-                {
-                  sumAux[cont] = vaux;
-                  indexAux[cont] = j;
-                  cont ++;
-                }
-            }
-        
-        }
-      index = indexAux;
-      sum = sumAux;
-      sizSum = size(sumAux);
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      // Sabemos que I ya viene dado por el sistema minimal de
+      // generadores, aunque aqui no sea necesario.
+      I = isMon[2];
+    }
+  }
+  attrib(I,"isSB",1);
+  return (dim(I));
+//  int nvar = nvars(basering);
+//  intvec index,indexAux,vaux,w;
+//  list sum, sumAux;
+//  // La base del ideal tiene que ser la monomial
+//  // Si el ideal es artiniano, es 0-dimensional
+//  if (isartinianMon(I) == 1)
+//  {
+//    return (0);
+//  }
+//  int sizI = ncols(I);
+//  // v(i) = vector con sizI entradas y donde cada entrada "j" se corresponde
+//  //        con el exponente del generador "i" en la variable "j"
+//  for (i = 1 ; i <= nvar ; i++)
+//  {
+//    intvec v(i);
+//    for (j = 1 ; j <= sizI ;j++ )
+//    {
+//      v(i)[j] = leadexp(I[j])[i];
+//    }
+//  }
+//  // Vamos a guardar en el vector "index" la ultima variable que se ha
+//  // sumado y en cada "sum(i)" el vector suma que se corresponde con la
+//  // entrada "i" del vector index.
+//  // Inicializo los valores de index y de cada sum
+//  w[sizI] = 0;
+//  sum[1] = w;
+//  index[1] = 0;
+//  sizSum = 1;
+//  while ( 1 )
+//  {
+//    cont = 1;
+//    sumandos ++;
+//    for (i = 1 ; i <= sizSum ; i ++)
+//    {
+//      for (j = index[i] + 1 ; j <= nvar ; j ++)
+//      {
+//        w = sum[i];
+//        vaux = w + v(j);
+//        // Comprobamos
+//        for (k = 1 ; k <= sizI ; k ++)
+//        {
+//          if (vaux[k] == 0)
+//          {
+//            break;
+//          }
+//        }
+//        if (k == sizI +1)
+//        {
+//          return (nvar - sumandos);
+//        }
+//        if (j <> nvar)
+//        {
+//          sumAux[cont] = vaux;
+//          indexAux[cont] = j;
+//          cont ++;
+//        }
+//      }
+//    }
+//    index = indexAux;
+//    sum = sumAux;
+//    sizSum = size(sumAux);
+//  }
 }
 example
@@ -1690,9 +1644,4 @@
 static proc irredDec1 (ideal I)
 {
-  // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
   // Variables
   int i,j,n,resp;
@@ -1700,5 +1649,4 @@
   intvec exp,v;
   ideal J,K;
-  ideal I = fetch(R,I);
   // ----- DESCOMPOSICION IRREDUCIBLE
   // Inicializamos la lista que va a estar formada por los ideales
@@ -1707,57 +1655,54 @@
   l1 = I;
   while (size(l1) > 0)
-    {
-      for (i = 1 ; i <= size(l1) ; i++)
-        {
-          J = l1[i];
-          n = size(J);
-          l1 = delete(l1,i);
-          // Llamamos a la funcion que va a detectar si el ideal es o
-          // no irreducible, y en caso de no serlo sabemos sobre que
-          // generador y con que variables hay que aplicar el
-          // el resultado teorico.
-          v = irredAux (J);
-          // No irreducible
-          if (size(v) > 1)
-            {
-              // En este caso, v[1] nos indica el generador del ideal
-              // que debemos eliminar.
-              exp = leadexp(J[v[1]]);
-              if (v[1] == 1)
-                {
-                  J = J[2..n];
-                }
-              if (v[1] > 1 && v[1] < n)
-                {
-                  J = J[1..v[1]-1],J[v[1]+1..n];
-                }
-              if (v[1] == n)
-                {
-                  J = J[1..n-1];
-                }
-              // Ahora vamos a introducir los nuevos generadores en
-              // cada uno de los nuevos ideales que generamos. Los
-              // ponemos en la lista en la que comprobamos.
-              for (j = 1 ; j <= size(v)-1 ; j++)
-                {
-                  K = J,x(v[j+1])^exp[v[j+1]];
-                  l1 = insert(l1,minbase(K));
-                }
-            }
-          // Si v[1]=0, el ideal es irreducible y lo introducimos en
-          // la lista l2, que es la que finalmente devolvera las
-          // componentes de la descomposicion.
-          else
-            {
-              l2 = insert(l2,J);
-            }
-        }
-    }
+  {
+    for (i = 1 ; i <= size(l1) ; i++)
+    {
+      J = l1[i];
+      n = ncols(J);
+      l1 = delete(l1,i);
+      // Llamamos a la funcion que va a detectar si el ideal es o
+      // no irreducible, y en caso de no serlo sabemos sobre que
+      // generador y con que variables hay que aplicar el
+      // el resultado teorico.
+      v = irredAux (J);
+      // No irreducible
+      if (size(v) > 1)
+      {
+        // En este caso, v[1] nos indica el generador del ideal
+        // que debemos eliminar.
+        exp = leadexp(J[v[1]]);
+        if (v[1] == 1)
+        {
+          J = J[2..n];
+        }
+        if (v[1] > 1 && v[1] < n)
+        {
+          J = J[1..v[1]-1],J[v[1]+1..n];
+        }
+        if (v[1] == n)
+        {
+          J = J[1..n-1];
+        }
+        // Ahora vamos a introducir los nuevos generadores en
+        // cada uno de los nuevos ideales que generamos. Los
+        // ponemos en la lista en la que comprobamos.
+        for (j = 1 ; j <= size(v)-1 ; j++)
+        {
+          K = J,var(v[j+1])^exp[v[j+1]];
+          l1 = insert(l1,minbase(K));
+        }
+      }
+      // Si v[1]=0, el ideal es irreducible y lo introducimos en
+      // la lista l2, que es la que finalmente devolvera las
+      // componentes de la descomposicion.
+      else
+      {
+        l2 = insert(l2,J);
+      }
+    }
+  }
   // ---- IRREDUNDANTE
   l2 = irredundant (l2);
   // La salida es la lista de los ideales irreducibles.
-  setring R;
-  list l2 = fetch(R1,l2);
-  kill R1;
   return (l2);
 }
@@ -1767,5 +1712,6 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc primDec1 (ideal I)  {
+static proc primDec1 (ideal I)
+{
   // Variables
   list l1,l2;
@@ -1779,5 +1725,5 @@
 // METODO 2: Metodo directo para descomp. primaria (ver Vasconcelos)
 //
-//////////////////////////////////////////////////////////////////////        
+//////////////////////////////////////////////////////////////////////
 // La siguiente funcion va a calcular una descomposicion primaria   //
 // minimal de un ideal monomial, pero esta vez usando la            //
@@ -1786,10 +1732,6 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc primDec2 (ideal I)  {
-  // Cambiamos de anillo
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+static proc primDec2 (ideal I)
+{
   // Variables en el nuevo anillo
   int i,n,max;
@@ -1797,5 +1739,4 @@
   intvec v;
   ideal J,K;
-  ideal I = fetch(R,I);
   // Vamos a tener dos listas: l1 que va a guardar todos los ideales
   // que vayamos generando con el resultado citado antes, que seran
@@ -1805,42 +1746,39 @@
   l1 = I;
   while (size(l1) > 0)
-    {
-      for (i = 1 ; i <= size(l1) ; i++)
-        {
-          J = l1[i];
-          n = size(J);
-          l1 = delete (l1,i);
-          // Usamos la funcion que hemos creado para saber si el ideal
-          // es primario. Si no lo es devuelve la variable que crea
-          // conflicto y los generadores del ideal que luego hay que
-          // usar (los que tienen productos de mas de una vble).
-          // Se le llama con el sistema minimal de generadores
-          v = primAux (J);
-          // En caso de no ser primario, hay que buscar el maximo
-          // exponente de la variable que aparece en los generadores
-          // del ideal multiplicada siempre por otras variables,
-          // nunca por si misma.
-          if (v[1] == 0)
-            {
-              max = maxExp(J,v);
-              K = J,x(v[2])^max;
-              l1 = insert (l1,minbase(K));
-              K = quotientIdealMon(J,x(v[2])^max);
-              // quotientidealMon devuelve sistema minimal de generadores
-              l1 = insert (l1,minbase(K));
-            }
-          // En caso de ser primario, lo introducimos en la lista
-          // conveniente.
-          else
-            {
-              l2 = insert (l2,J);
-            }
-        }
-    }
+  {
+    for (i = 1 ; i <= size(l1) ; i++)
+    {
+      J = l1[i];
+      n = ncols(J);
+      l1 = delete (l1,i);
+      // Usamos la funcion que hemos creado para saber si el ideal
+      // es primario. Si no lo es devuelve la variable que crea
+      // conflicto y los generadores del ideal que luego hay que
+      // usar (los que tienen productos de mas de una vble).
+      // Se le llama con el sistema minimal de generadores
+      v = primAux (J);
+      // En caso de no ser primario, hay que buscar el maximo
+      // exponente de la variable que aparece en los generadores
+      // del ideal multiplicada siempre por otras variables,
+      // nunca por si misma.
+      if (v[1] == 0)
+      {
+        max = maxExp(J,v);
+        K = J,var(v[2])^max;
+        l1 = insert (l1,minbase(K));
+        K = quotientIdealMon(J,var(v[2])^max);
+        // quotientidealMon devuelve sistema minimal de generadores
+        l1 = insert (l1,minbase(K));
+      }
+      // En caso de ser primario, lo introducimos en la lista
+      // conveniente.
+      else
+      {
+        l2 = insert (l2,J);
+      }
+    }
+  }
 // ------   IRREDUNDANTE
   l2 = irredundant (l2);
-  setring R;
-  list l2 = fetch (R1,l2);
-  kill R1;
   return (l2);
 }
@@ -1854,6 +1792,6 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc irredDec3 (ideal I)  {
-  def R = basering;
+static proc irredDec3 (ideal I)
+{
   int i,n,j;
   poly lcm;
@@ -1862,10 +1800,10 @@
   list l;
   // Hallamos el m.c.m. de los generadores minimales del ideal.
-  n = size (I);
+  n = ncols (I);
   lcm = I[1];
   for ( i = 2 ; i <= n ; i++ )
-    {
-      lcm = lcmMon (lcm,I[i]);
-    }
+  {
+    lcm = lcmMon (lcm,I[i]);
+  }
   v = leadexp (lcm);
   // Calculamos el dual de Alexander.
@@ -1889,5 +1827,6 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc primDec3 (ideal I)   {
+static proc primDec3 (ideal I)
+{
   // Variables
   list l1,l2;
@@ -1907,10 +1846,8 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc irredDec4 (ideal I)  {
+static proc irredDec4 (ideal I)
+{
   // Cambiamos de anillo.
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int nvar = nvars(basering);
  // Variables
   int n,i,j,m,resp;
@@ -1919,12 +1856,11 @@
   ideal J,K;
   list L;
-  ideal I = fetch (R,I);
   // Calculamos el l.c.m. de los generadores minimales del ideal.
-  n = size (I);
+  n = ncols (I);
   lcm = I[1];
   for ( i = 2 ; i <= n ; i++ )
-    {
-      lcm = lcmMon (lcm,I[i]);
-    }
+  {
+    lcm = lcmMon (lcm,I[i]);
+  }
   v = leadexp (lcm);
   // Hallamos el ideal J = (x(1)^(l(1)+1),...,x(n)^(l(n)+1)). Como
@@ -1933,7 +1869,7 @@
   // el ideal J.
   for ( i = 1 ; i <= nvar ; i++ )
-    {
-      J[i] = (x(i))^(v[i]+1);
-    }
+  {
+    J[i] = (var(i))^(v[i]+1);
+  }
   // Ahora hacemos el cociente oportuno.
   K = minbase(quotient (J,I));
@@ -1941,13 +1877,13 @@
   // generadores de J. Los generadores que son divisibles los hacemos
   // cero y luego los eliminamos.
-  m = size (K);
+  m = ncols (K);
   for ( i = 1 ; i <= m ; i++ )
-    {
-      resp = membershipMon(K[i],J);
-      if ( resp == 1)
-        {
-          K[i] = 0;
-        }
-    }
+  {
+    resp = membershipMon(K[i],J);
+    if ( resp == 1)
+    {
+      K[i] = 0;
+    }
+  }
   K = simplify (K,2);
   // Ahora obtenemos las componentes de la descomposicion irreducible,
@@ -1956,7 +1892,4 @@
   // Volvemos al anillo de partida y devolvemos la lista de las
   // componentes irreducibles irredundantes.
-  setring R;
-  list L = fetch(R1,L);
-  kill R1;
   return (L);
 }
@@ -1967,5 +1900,6 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc primDec4 (ideal I) {
+static proc primDec4 (ideal I)
+{
   // Variables
   list l1,l2;
@@ -1987,10 +1921,5 @@
 static proc irredDec5 (ideal I)
 {
-  // New ring
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
-  ideal I = fetch (R,I);
+  int nvar = nvars(basering);
   //Variables
   int i,j;
@@ -1999,79 +1928,76 @@
   list artiniano = artinian (I);
   if (artiniano[1] == 0)
-    {
-      I = artiniano[2];
-      intvec elimina = artiniano[3];
-    }
+  {
+    I = artiniano[2];
+    intvec elimina = artiniano[3];
+  }
   // Quotient
-  ideal M = (x(1..nvar));
+  ideal M = maxideal(1);
   ideal J = quotient (I,M);
   // Deleting generators lying in I
-  for (i = 1 ; i <= size(J) ; i ++)
-    {
-      if (membershipMon(J[i],I) == 1)
-        {
-          if (i == 1)
-            {
-              J = J[2..size(J)];
-              i --;
-            }
-          else
-            {
-              if (i == size(J))
-                {
-                  J = J[1..size(J)-1];
-                  i --;
-                }
-              else
-                {
-                  J = J[1..i-1],J[i+1..size(J)];
-                  i --;
-                }
-            }
-        }
-    }
+  for (i = 1 ; i <= ncols(J) ; i ++)
+  {
+    if (membershipMon(J[i],I) == 1)
+    {
+      if (i == 1)
+      {
+        J = J[2..ncols(J)];
+        i --;
+      }
+      else
+      {
+        if (i == ncols(J))
+        {
+          J = J[1..i-1];
+          i --;
+        }
+        else
+        {
+          J = J[1..i-1],J[i+1..ncols(J)];
+          i --;
+        }
+      }
+    }
+  }
   // Exponents of the ideals are going to form the decomposition
-  int sizJ = size(J);
+  int sizJ = ncols(J);
   for (i = 1 ; i <= sizJ ; i ++ )
-    {
-      intvec exp(i) = leadexp(J[i]) + 1;
-    }
+  {
+    intvec exp(i) = leadexp(J[i]) + 1;
+  }
   // Deleting artinianization process
   if (artiniano[1] == 0)
-   {
-     // En elimina estan guardadas las variables que hay que eliminar
-     for (i = 1 ; i <= nvar ; i ++)
-       {
-         if (elimina[i] <> 0)
-           {
-             for (j = 1 ; j <= sizJ ; j ++)
-               {
-                 if (exp(j)[i] == elimina[i])
-                   {
-                     exp(j)[i] = 0;
-                   }
-               }
-           }
-       }
-   }
+  {
+    // En elimina estan guardadas las variables que hay que eliminar
+    for (i = 1 ; i <= nvar ; i ++)
+    {
+      if (elimina[i] <> 0)
+      {
+        for (j = 1 ; j <= sizJ ; j ++)
+        {
+          if (exp(j)[i] == elimina[i])
+          {
+            exp(j)[i] = 0;
+          }
+        }
+      }
+    }
+  }
   // En exp(i) tengo los exponentes de cada variable de las que aparecen
   // en cada ideal.
   list facets;
   for (i = 1 ; i <= sizJ ; i ++)
-    {
-      J = 0;
-      for (j = 1 ; j <= nvar ; j ++)
-        {
-          if (exp(i)[j] <> 0)
-            {
-              J = J,x(j)^exp(i)[j];
-            }
-        }
-      J = simplify(J,2);
-      facets[i] = J;
-    }
-  setring R;
-  list facets = fetch (R1,facets);
-  kill R1;
+  {
+    J = 0;
+    for (j = 1 ; j <= nvar ; j ++)
+    {
+      if (exp(i)[j] <> 0)
+      {
+        J = J,var(j)^exp(i)[j];
+      }
+    }
+    J = simplify(J,2);
+    facets[i] = J;
+  }
   return (facets);
 }
@@ -2082,5 +2008,6 @@
 //////////////////////////////////////////////////////////////////////
 //
-static proc primDec5 (ideal I) {
+static proc primDec5 (ideal I)
+{
   // Variables
   list l1,l2;
@@ -2108,14 +2035,14 @@
   int max,j,k,sizI;
   intvec exp;
-  sizI = size(I);
+  sizI = ncols(I);
   max = 0;
   for (j = 1 ; j <= sizI ; j ++)
-    {
-      exp = leadexp(I[j]);
-      if ( exp[i] > max)
-        {
-          max = exp[i];
-        }
-    }
+  {
+    exp = leadexp(I[j]);
+    if ( exp[i] > max)
+    {
+      max = exp[i];
+    }
+  }
   return(max);
 }
@@ -2130,8 +2057,5 @@
 {
   // Cambiamos de anillo
-  def R = basering;
-  int  nvar  = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
+  int  nvar  = nvars(basering);
   // Declaracion de variables
   int i,j,k,cont1,cont2,sizI,marcavar,max;
@@ -2139,82 +2063,77 @@
   list nuevo;
   ideal J;
-  ideal I = fetch(R,I);
-  sizI = size(I);
+  sizI = ncols(I);
   // Comprobamos que entre los generadores minimales aparece una
   // potencia de cada
   cont2 = 0;
   for (i = 1 ; i <= sizI ; i++)
-    {
-      v = leadexp(I[i]);
-      marcavar  = 0;
-      cont1 = 0;
-      for (j = 1 ; j <= nvar ; j++)
-        {
-          if (v[j] <> 0)
-            {
-              cont1 ++;
-              marcavar = j;
-            }
-        }
-      // Si cont1=1 hemos encontrado un generador de los que nos
-      // interesa."variablesin" guarda el indice de las que estan.
-      if (cont1 == 1)
-        {
-          cont2 ++;
-          variablesin[cont2] = marcavar;
-        }
-    }
+  {
+    v = leadexp(I[i]);
+    marcavar  = 0;
+    cont1 = 0;
+    for (j = 1 ; j <= nvar ; j++)
+    {
+      if (v[j] <> 0)
+      {
+        cont1 ++;
+        marcavar = j;
+      }
+    }
+    // Si cont1=1 hemos encontrado un generador de los que nos
+    // interesa."variablesin" guarda el indice de las que estan.
+    if (cont1 == 1)
+    {
+      cont2 ++;
+      variablesin[cont2] = marcavar;
+    }
+  }
   // Notar que como el sistema de generadores es minimal no se
   // va a repetir la potencia de la misma variable. Por tanto basta
   // comprobar si cont2 es o no nvar.
   if (cont2 == nvar)
-    {
-      setring R;
-      list output;
-      output[1] = 1;
-      return(output);
-    }
+  {
+    list output;
+    output[1] = 1;
+    return(output);
+  }
   else
-    {
-      J = I;
-      // Buscamos las que no estan
-      if (cont2 == 0)
-        {
-          for (i = 1 ; i <= nvar ; i ++)
-            {
-              max = maximoExp(I,i);
-              cambio[i] = max + 1;
-              J = J,x(i)^(max + 1);
-            }
-        }
-      else
-        {
-          for (i = 1 ; i <= nvar ; i++)
-            {
-              for (j = 1 ; j <= cont2 ; j ++)
-                {
-                  if (i == variablesin[j])
-                    {
-                      cambio[i] = 0;
-                      break;
-                    }
-                }
-              if (j == cont2 + 1)
-                {
-                  max = maximoExp(I,i);
-                  cambio[i] = max + 1;
-                  J = J,x(i)^(max + 1);
-                }
-            }
-        }
-      list output;
-      output[1] = 0;
-      output[2] = J;
-      output[3] = cambio;
-      setring R;
-      list output = fetch (R1,output);
-      kill R1;
-      return(output);
-    }
+  {
+    J = I;
+    // Buscamos las que no estan
+    if (cont2 == 0)
+    {
+      for (i = 1 ; i <= nvar ; i ++)
+      {
+        max = maximoExp(I,i);
+        cambio[i] = max + 1;
+        J = J,var(i)^(max + 1);
+      }
+    }
+    else
+    {
+      for (i = 1 ; i <= nvar ; i++)
+      {
+        for (j = 1 ; j <= cont2 ; j ++)
+        {
+          if (i == variablesin[j])
+          {
+            cambio[i] = 0;
+            break;
+          }
+        }
+        if (j == cont2 + 1)
+        {
+          max = maximoExp(I,i);
+          cambio[i] = max + 1;
+          J = J,var(i)^(max + 1);
+        }
+      }
+    }
+    list output;
+    output[1] = 0;
+    output[2] = J;
+    output[3] = cambio;
+    return(output);
+  }
 }
 //////////////////////////////////////////////////////////////////////
@@ -2227,19 +2146,15 @@
 {
   // New ring
-  def R = basering;
-  int nvar = nvars(R);
-   string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-   execute(s);
-   ideal I = fetch(R,I);
+  int nvar = nvars(basering);
   // VARIABLES
   int i,j,k;
   // Cargamos la matriz con los exponentes
-  int sizI = size(I);
+  int sizI = ncols(I);
   intmat EXP[sizI][nvar];
   for (i = 1 ; i <= sizI ; i ++)
-    {
-      // Ordenamos el vector de exponentes oportuno
-      EXP[i,1..nvar] = leadexp(I[i]);
-    }
+  {
+    // Ordenamos el vector de exponentes oportuno
+    EXP[i,1..nvar] = leadexp(I[i]);
+  }
 
   // Ahora tenemos que ordenarla segun la variable que este en conficto.
